-- potash.lua 
-- Boils water in kettles to make potash.
-- Pin any number of kettles and begin. If the kettles go out for whatever
-- reason (missed a stoke or whatever), just break out and restart the script.

-- It always assumes you want a full run, so if you don't want this, be 
-- sure to stop it when your kettles are finished.

-- An intermittant issue exists where it misses the last 'Max' stoke button
-- in a collection of kettles. I haven't been able to figure out why yet. 
-- Just keep an eye out for 'waiting' while a stoke popup exists. Just mouse
--  over and click max, the script will pick up from where you saved it. 

-- Do not forget to put all the .png files in your VT folder, not the 
-- luaScripts sub-folder. 

-- Feedback and/or improvments are MOST welcome.

-- Released to the public domain, where i got my original start.
-- prophet 18 Jan 2012


loadfile("luaScripts/screen_reader_common.inc")();
loadfile("luaScripts/ui_utils.inc")();
loadfile("luaScripts/kettles.inc")();

per_click_delay = 100;

function makePotash()

  local image_name = "Potash.png";
  -- Find potash buttons and click them!
  srReadScreen();
  local buttons = findAllImages(image_name);
  
  if #buttons == 0 then
    statusScreen("Could not find any potash buttons, soldiering on...");
    lsSleep(1500);
  else
    -- statusScreen("Clicking " .. #buttons .. " potash button(s)...");
    for i=#buttons, 1, -1 do
      srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3, right_click);
      lsSleep(per_click_delay);
    end
    statusScreen("Done clicking (" .. #buttons .. " kettles).");
    lsSleep(100);
  end

  local image_name = "Begin.png";

  -- Find begin buttons and click them!
  srReadScreen();
  local buttons = findAllImages(image_name);
  
  if #buttons == 0 then
    statusScreen("Could not find any begin buttons, continuing...");
    lsSleep(1500);
  else
    -- statusScreen("Clicking " .. #buttons .. " Begin button(s)...");
    for i=#buttons, 1, -1 do
      srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3, right_click);
      lsSleep(per_click_delay);
    end
    statusScreen("Done clicking (" .. #buttons .. " kettles).");
    for j=1, 2 do
      statusScreen("Ready to Ignite...");
      lsSleep(1000);
    end;
  end
end

function makeSalt()
  local image_name = "SaltButton.png";
  -- Find potash buttons and click them!
  srReadScreen();
  local buttons = findAllImages(image_name);
  
  if #buttons == 0 then
    statusScreen("Could not find any potash buttons, soldiering on...");
    lsSleep(1500);
  else
    -- statusScreen("Clicking " .. #buttons .. " potash button(s)...");
    for i=#buttons, 1, -1 do
      srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3, right_click);
      lsSleep(per_click_delay);
    end
    statusScreen("Done clicking (" .. #buttons .. " kettles).");
    lsSleep(100);
  end

  local image_name = "Begin.png";

  -- Find begin buttons and click them!
  srReadScreen();
  local buttons = findAllImages(image_name);
  
  if #buttons == 0 then
    statusScreen("Could not find any begin buttons, continuing...");
    lsSleep(1500);
  else
    -- statusScreen("Clicking " .. #buttons .. " Begin button(s)...");
    for i=#buttons, 1, -1 do
      srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3, right_click);
      lsSleep(per_click_delay);
    end
    statusScreen("Done clicking (" .. #buttons .. " kettles).");
    for j=1, 2 do
      statusScreen("Ready to Ignite...");
      lsSleep(1000);
    end;
  end  
end

function doit()
  stokeCounter = 0;
	askForWindow("Pin any number of kettles, after selecting the game window, press shift.");
  
  -- call potash
  makePotash();
  -- call potash
  makeSalt();

  --call ignite
  igniteM();

  stokeTimer(70);
  stokeM();

  -- say goodnight gracie
  for fl=5, 1, -1 do
    stokeTimer(131);
    stokeM();
  end

end
